//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//  product: usb-watchdog-stick (ModuleID = USB_WATCHDOG)
//  configuration: digital-outputs
//  programming language: vc
//
//
//  (c) DEDITEC GmbH, 2013
//  web: http://www.deditec.de/
//  mail: vertrieb@deditec.de
//
// 
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
// Please include the following library on linking: delib.lib
//
// This can be done at the project settings (Project/Settings/Link -> 
// Object/library modules) .. extend the existing line with the ending 
// "$(DELIB_LIB)\delib.lib"		(with quotation marks)
//
// Including the header file delib.h (Project/Settings/C/C++ -> select category 
// "Preprocessor" -> Additional inlude directories) .. enter the line 
// "$(DELIB_INCLUDE)"	(with quotation marks)


#include <windows.h>
#include <stdio.h>
#include "conio.h"

#include "delib.h"

// ---------------------------------------------------------------------------
// GetLastError function

BOOL IsError()
{
	unsigned char msg[500];

	if (DapiGetLastError () != DAPI_ERR_NONE)
	{

		DapiGetLastErrorText((unsigned char*) msg, sizeof(msg));
		printf ("Error Code = %x * Message = %s\n", 0, msg);

		DapiClearLastError();

		return TRUE;
	}

	return FALSE;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void main(void)
{
	unsigned long handle; 
	unsigned long retriggercounter = 1;
	bool isneverfalse = true;


	// ---------------------------------------------------------------------------
	// Open Module

	handle = DapiOpenModule(USB_WATCHDOG, 0);

	// ---------------------------------------------------------------------------
	// Module not found!

	if (handle==0)
	{
		printf("Could not open module!\n");
		printf("Press any key to exit\n");
		getch();
		return;
	}

	// ---------------------------------------------------------------------------
	// Module found!

	printf("Module handle = %x\n", handle);
	printf("Module has been opened\n");
	printf("Start monitoring * Retrigger-Intervall = 2sec\n");


	// ---------------------------------------------------------------------------
	// Activate watchdog + endless retrigger loop

	DapiWatchdogEnable(handle);
	IsError();

	while (isneverfalse)
	{
		DapiWatchdogRetrigger(handle);
		IsError();
		printf("Retrigger no. %d %c", retriggercounter, 13);
		retriggercounter += 1;
		Sleep(2000);
	}

	return ;
}
